(*
  Machine generated. Edit at your own risk 
  Reproduce with the following
 --pickler=std,sexp
 --lang=sml
 *)
structure Camelot_absyn_ASDLUtil  =
  struct
    
fun myRealfromString s =
    case Real.fromString s of
      NONE => raise Fail "Pickler Error"
      | SOME(r) => r

    fun read_loc s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => ((fn(Camelot_absyn_ASDL.Loc(i,j))=>Location.Loc(i,j)) let
                  val f0 = (StdPrimsUtil.read_int s_)
                  val f1 = (StdPrimsUtil.read_int s_)
                in Camelot_absyn_ASDL.Loc(f0, f1)
                end)
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_float s_ = 
        let
          val f0 = (StdPrimsUtil.read_string s_)
        in (myRealfromString (f0))
        end
    
    and read_assn s_ = 
        let
          val f0 = (Assertions_ASDLUtil.read_assn s_)
        in (f0)
        end
    
    and read_varNm s_ = 
        let
          val f0 = (StdPrimsUtil.read_string s_)
        in (f0)
        end
    
    and read_tVarNmL s_ = 
        let
          val f0 = (read_loc s_)
          val f1 = (StdPrimsUtil.read_string s_)
        in (f0, f1)
        end
    
    and read_tVarNm s_ = 
        let
          val f0 = (StdPrimsUtil.read_string s_)
        in (f0)
        end
    
    and read_ty s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => Camelot_absyn_ASDL.INTty
          | 2 => Camelot_absyn_ASDL.BOOLty
          | 3 => Camelot_absyn_ASDL.CHARty
          | 4 => Camelot_absyn_ASDL.BYTEty
          | 5 => Camelot_absyn_ASDL.SHORTty
          | 6 => Camelot_absyn_ASDL.LONGty
          | 7 => Camelot_absyn_ASDL.FLOATty
          | 8 => Camelot_absyn_ASDL.DOUBLEty
          | 9 => Camelot_absyn_ASDL.STRINGty
          | 10 => Camelot_absyn_ASDL.UNITty
          | 11 => let
              val f0 = (read_tVarNm s_)
            in Camelot_absyn_ASDL.TVARty(f0)
            end
          | 12 => let
              val f0 = (read_ty s_)
            in Camelot_absyn_ASDL.ARRAYty(f0)
            end
          | 13 => let
              val f0 = (StdPkl.read_list read_ty s_)
            in Camelot_absyn_ASDL.PRODUCTty(f0)
            end
          | 14 => let
              val f0 = (read_ty s_)
              val f1 = (read_ty s_)
            in Camelot_absyn_ASDL.ARROWty(f0, f1)
            end
          | 15 => let
              val f0 = (StdPkl.read_list read_ty s_)
              val f1 = (StdPrimsUtil.read_string s_)
            in Camelot_absyn_ASDL.CONty(f0, f1)
            end
          | 16 => let
              val f0 = (StdPrimsUtil.read_string s_)
            in Camelot_absyn_ASDL.DIAMONDty(f0)
            end
          | 17 => let
              val f0 = (StdPrimsUtil.read_string s_)
            in Camelot_absyn_ASDL.OBJECTty(f0)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_heapUsage s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => Camelot_absyn_ASDL.HEAP
          | 2 => Camelot_absyn_ASDL.NOHEAP
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_typeCon s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (read_varNm s_)
              val f1 = (StdPkl.read_list read_ty s_)
              val f2 = (read_heapUsage s_)
            in Camelot_absyn_ASDL.TYPEcon(f0, f1, f2)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_typeConL s_ = 
        let
          val f0 = (read_loc s_)
          val f1 = (read_typeCon s_)
        in (f0, f1)
        end
    
    and read_typeDec s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (StdPkl.read_list read_tVarNmL s_)
              val f1 = (read_varNm s_)
              val f2 = (StdPkl.read_list read_typeConL s_)
            in Camelot_absyn_ASDL.TYPEdec(f0, f1, f2)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_typeDecL s_ = 
        let
          val f0 = (read_loc s_)
          val f1 = (read_typeDec s_)
        in (f0, f1)
        end
    
    and read_funAssns s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (read_varNm s_)
              val f1 = (StdPkl.read_list read_assn s_)
              val f2 = (StdPkl.read_list read_assn s_)
            in Camelot_absyn_ASDL.FUNASSNS(f0, f1, f2)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_hints s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (StdPkl.read_list read_typeDecL s_)
              val f1 = (StdPkl.read_list read_funAssns s_)
            in Camelot_absyn_ASDL.HINTS(f0, f1)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_rich_constructor s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (StdPrimsUtil.read_string s_)
              val f1 = (StdPkl.read_list read_rich_ty s_)
              val f2 = (StdPrimsUtil.read_int s_)
            in Camelot_absyn_ASDL.RICH_CON(f0, f1, f2)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_rich_ty s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => Camelot_absyn_ASDL.RICH_INTty
          | 2 => Camelot_absyn_ASDL.RICH_BOOLty
          | 3 => Camelot_absyn_ASDL.RICH_CHARty
          | 4 => Camelot_absyn_ASDL.RICH_BYTEty
          | 5 => Camelot_absyn_ASDL.RICH_SHORTty
          | 6 => Camelot_absyn_ASDL.RICH_LONGty
          | 7 => Camelot_absyn_ASDL.RICH_FLOATty
          | 8 => Camelot_absyn_ASDL.RICH_DOUBLEty
          | 9 => Camelot_absyn_ASDL.RICH_STRINGty
          | 10 => Camelot_absyn_ASDL.RICH_UNITty
          | 11 => let
              val f0 = (read_tVarNm s_)
            in Camelot_absyn_ASDL.RICH_TVARty(f0)
            end
          | 12 => let
              val f0 = (read_rich_ty s_)
            in Camelot_absyn_ASDL.RICH_ARRAYty(f0)
            end
          | 13 => let
              val f0 = (StdPkl.read_list read_rich_ty s_)
            in Camelot_absyn_ASDL.RICH_PRODUCTty(f0)
            end
          | 14 => let
              val f0 = (read_rich_ty s_)
              val f1 = (read_rich_ty s_)
            in Camelot_absyn_ASDL.RICH_ARROWty(f0, f1)
            end
          | 15 => let
              val f0 = (StdPkl.read_list read_rich_ty s_)
              val f1 = (read_varNm s_)
              val f2 = (StdPkl.read_list read_rich_constructor s_)
            in Camelot_absyn_ASDL.RICH_CONty(f0, f1, f2)
            end
          | 16 => let
              val f0 = (StdPrimsUtil.read_string s_)
            in Camelot_absyn_ASDL.RICH_DIAMONDty(f0)
            end
          | 17 => let
              val f0 = (StdPrimsUtil.read_string s_)
            in Camelot_absyn_ASDL.RICH_OBJECTty(f0)
            end
          | 18 => Camelot_absyn_ASDL.RICH_SELFty
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_rich_valdec s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (StdPrimsUtil.read_string s_)
              val f1 = (StdPrimsUtil.read_int s_)
              val f2 = (read_rich_ty s_)
              val f3 = (StdPrimsUtil.read_int s_)
            in Camelot_absyn_ASDL.RICH_VALDEC(f0, f1, f2, f3)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_external s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => Camelot_absyn_ASDL.GLOBAL
          | 2 => Camelot_absyn_ASDL.LOCAL
          | 3 => Camelot_absyn_ASDL.BUILTIN
          | 4 => Camelot_absyn_ASDL.EXTERN
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_boolX s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => Camelot_absyn_ASDL.TRUEval
          | 2 => Camelot_absyn_ASDL.FALSEval
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_value s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (read_varNm s_)
              val f1 = (read_external s_)
            in Camelot_absyn_ASDL.VARval(f0, f1)
            end
          | 2 => let
              val f0 = (StdPrimsUtil.read_int s_)
            in Camelot_absyn_ASDL.CHARval(f0)
            end
          | 3 => let
              val f0 = (StdPrimsUtil.read_int s_)
            in Camelot_absyn_ASDL.INTval(f0)
            end
          | 4 => let
              val f0 = (read_float s_)
            in Camelot_absyn_ASDL.FLOATval(f0)
            end
          | 5 => let
              val f0 = (StdPrimsUtil.read_string s_)
            in Camelot_absyn_ASDL.STRINGval(f0)
            end
          | 6 => let
              val f0 = (read_boolX s_)
            in Camelot_absyn_ASDL.BOOLval(f0)
            end
          | 7 => Camelot_absyn_ASDL.UNITval
          | 8 => Camelot_absyn_ASDL.NULLval
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_unaryOperator s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => Camelot_absyn_ASDL.NOTop
          | 2 => Camelot_absyn_ASDL.ISNULLop
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_binaryOperator s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => Camelot_absyn_ASDL.PLUSop
          | 2 => Camelot_absyn_ASDL.MINUSop
          | 3 => Camelot_absyn_ASDL.TIMESop
          | 4 => Camelot_absyn_ASDL.DIVop
          | 5 => Camelot_absyn_ASDL.MODop
          | 6 => Camelot_absyn_ASDL.LANDop
          | 7 => Camelot_absyn_ASDL.LORop
          | 8 => Camelot_absyn_ASDL.LXORop
          | 9 => Camelot_absyn_ASDL.LSLop
          | 10 => Camelot_absyn_ASDL.LSRop
          | 11 => Camelot_absyn_ASDL.ASRop
          | 12 => Camelot_absyn_ASDL.FPLUSop
          | 13 => Camelot_absyn_ASDL.FMINUSop
          | 14 => Camelot_absyn_ASDL.FTIMESop
          | 15 => Camelot_absyn_ASDL.FDIVop
          | 16 => Camelot_absyn_ASDL.LESSop
          | 17 => Camelot_absyn_ASDL.LEQop
          | 18 => Camelot_absyn_ASDL.EQUALSop
          | 19 => Camelot_absyn_ASDL.CONCATop
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_varNmL s_ = 
        let
          val f0 = (read_loc s_)
          val f1 = (StdPrimsUtil.read_string s_)
        in (f0, f1)
        end
    
    and read_matchDiam s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => Camelot_absyn_ASDL.NOWHERE
          | 2 => let
              val f0 = (read_varNmL s_)
            in Camelot_absyn_ASDL.SOMEWHERE(f0)
            end
          | 3 => Camelot_absyn_ASDL.DISPOSE
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_ooMatchPat s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (read_varNm s_)
              val f1 = (read_varNm s_)
            in Camelot_absyn_ASDL.CLASSpat(f0, f1)
            end
          | 2 => Camelot_absyn_ASDL.ANYCLASSpat
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_instance s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => Camelot_absyn_ASDL.INSTANCE
          | 2 => Camelot_absyn_ASDL.STATIC
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_valDec s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (read_varNm s_)
              val f1 = (read_ty s_)
              val f2 = (read_instance s_)
            in Camelot_absyn_ASDL.VALdec(f0, f1, f2)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_fieldDec s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (read_varNm s_)
              val f1 = (read_ty s_)
              val f2 = (read_instance s_)
            in Camelot_absyn_ASDL.FIELDdec(f0, f1, f2)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_classDec s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (read_varNm s_)
              val f1 = (StdPkl.read_option read_varNm s_)
              val f2 = (StdPkl.read_list read_varNm s_)
              val f3 = (StdPkl.read_list read_valDec s_)
            in Camelot_absyn_ASDL.CLASSdec(f0, f1, f2, f3)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_varTy s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => Camelot_absyn_ASDL.UNITvar
          | 2 => let
              val f0 = (StdPrimsUtil.read_string s_)
              val f1 = (StdPkl.read_option read_ty s_)
            in Camelot_absyn_ASDL.VAR(f0, f1)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_test s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (read_binaryOperator s_)
              val f1 = (read_value s_)
              val f2 = (read_value s_)
            in Camelot_absyn_ASDL.TEST(f0, f1, f2)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_oomatchRule s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (read_ooMatchPat s_)
              val f1 = (read_expL s_)
            in Camelot_absyn_ASDL.OOMATCHrule(f0, f1)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_oomatchRuleL s_ = 
        let
          val f0 = (read_loc s_)
          val f1 = (read_oomatchRule s_)
        in (f0, f1)
        end
    
    and read_matchRule s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (read_varNmL s_)
              val f1 = (StdPkl.read_list read_varNmL s_)
              val f2 = (read_matchDiam s_)
              val f3 = (read_expL s_)
            in Camelot_absyn_ASDL.MATCHrule(f0, f1, f2, f3)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_matchRuleL s_ = 
        let
          val f0 = (read_loc s_)
          val f1 = (read_matchRule s_)
        in (f0, f1)
        end
    
    and read_expL s_ = 
        let
          val f0 = (read_loc s_)
          val f1 = (read_exp s_)
        in (f0, f1)
        end
    
    and read_exp s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (read_value s_)
            in Camelot_absyn_ASDL.VALexp(f0)
            end
          | 2 => let
              val f0 = (read_unaryOperator s_)
              val f1 = (read_value s_)
            in Camelot_absyn_ASDL.UNARYexp(f0, f1)
            end
          | 3 => let
              val f0 = (read_binaryOperator s_)
              val f1 = (read_value s_)
              val f2 = (read_value s_)
            in Camelot_absyn_ASDL.BINexp(f0, f1, f2)
            end
          | 4 => let
              val f0 = (read_varNm s_)
              val f1 = (StdPkl.read_list read_value s_)
              val f2 = (read_external s_)
            in Camelot_absyn_ASDL.APPexp(f0, f1, f2)
            end
          | 5 => let
              val f0 = (read_varNm s_)
              val f1 = (StdPkl.read_list read_value s_)
              val f2 = (StdPkl.read_option read_varNmL s_)
            in Camelot_absyn_ASDL.CONexp(f0, f1, f2)
            end
          | 6 => let
              val f0 = (read_varNm s_)
              val f1 = (StdPrimsUtil.read_string s_)
              val f2 = (StdPkl.read_list read_value s_)
            in Camelot_absyn_ASDL.INVOKEexp(f0, f1, f2)
            end
          | 7 => let
              val f0 = (read_varNm s_)
              val f1 = (StdPkl.read_list read_value s_)
            in Camelot_absyn_ASDL.NEWexp(f0, f1)
            end
          | 8 => let
              val f0 = (read_varNm s_)
              val f1 = (read_varNm s_)
            in Camelot_absyn_ASDL.GETexp(f0, f1)
            end
          | 9 => let
              val f0 = (read_varNm s_)
            in Camelot_absyn_ASDL.SGETexp(f0)
            end
          | 10 => let
              val f0 = (read_varNm s_)
              val f1 = (read_value s_)
            in Camelot_absyn_ASDL.UPDATEexp(f0, f1)
            end
          | 11 => let
              val f0 = (StdPkl.read_list read_value s_)
            in Camelot_absyn_ASDL.SUPERMAKERexp(f0)
            end
          | 12 => let
              val f0 = (read_varNm s_)
              val f1 = (read_ty s_)
            in Camelot_absyn_ASDL.COERCEexp(f0, f1)
            end
          | 13 => let
              val f0 = (read_varNm s_)
              val f1 = (read_expL s_)
              val f2 = (read_expL s_)
            in Camelot_absyn_ASDL.LETexp(f0, f1, f2)
            end
          | 14 => let
              val f0 = (read_test s_)
              val f1 = (read_expL s_)
              val f2 = (read_expL s_)
            in Camelot_absyn_ASDL.IFexp(f0, f1, f2)
            end
          | 15 => let
              val f0 = (read_varNm s_)
              val f1 = (StdPkl.read_list read_matchRuleL s_)
            in Camelot_absyn_ASDL.MATCHexp(f0, f1)
            end
          | 16 => let
              val f0 = (read_varNm s_)
              val f1 = (StdPkl.read_list read_oomatchRuleL s_)
            in Camelot_absyn_ASDL.OOMATCHexp(f0, f1)
            end
          | 17 => let
              val f0 = (read_expL s_)
              val f1 = (read_ty s_)
            in Camelot_absyn_ASDL.TYPEDexp(f0, f1)
            end
          | 18 => let
              val f0 = (read_expL s_)
              val f1 = (StdPkl.read_list read_assn s_)
              val f2 = (StdPkl.read_list read_assn s_)
            in Camelot_absyn_ASDL.ASSERTexp(f0, f1, f2)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_varTyL s_ = 
        let
          val f0 = (read_loc s_)
          val f1 = (read_varTy s_)
        in (f0, f1)
        end
    
    and read_funDef s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (read_varNm s_)
              val f1 = (StdPkl.read_list read_varTyL s_)
              val f2 = (read_instance s_)
              val f3 = (read_expL s_)
            in Camelot_absyn_ASDL.FUNdef(f0, f1, f2, f3)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_fieldDecL s_ = 
        let
          val f0 = (read_loc s_)
          val f1 = (read_fieldDec s_)
        in (f0, f1)
        end
    
    and read_funDefL s_ = 
        let
          val f0 = (read_loc s_)
          val f1 = (read_funDef s_)
        in (f0, f1)
        end
    
    and read_classDef s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (read_varNm s_)
              val f1 = (StdPkl.read_option read_varNm s_)
              val f2 = (StdPkl.read_list read_varNm s_)
              val f3 = (StdPkl.read_list read_fieldDecL s_)
              val f4 = (StdPkl.read_list read_funDefL s_)
            in Camelot_absyn_ASDL.CLASSdef(f0, f1, f2, f3, f4)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_classDecL s_ = 
        let
          val f0 = (read_loc s_)
          val f1 = (read_classDec s_)
        in (f0, f1)
        end
    
    and read_classDefL s_ = 
        let
          val f0 = (read_loc s_)
          val f1 = (read_classDef s_)
        in (f0, f1)
        end
    
    and read_valDecL s_ = 
        let
          val f0 = (read_loc s_)
          val f1 = (read_valDec s_)
        in (f0, f1)
        end
    
    and read_funBlock s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (StdPkl.read_list read_funDefL s_)
            in Camelot_absyn_ASDL.FUNblock(f0)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_program s_ = 
        let
          val t = (StdPkl.read_tag s_)
        in (case (t) of 
            1 => let
              val f0 = (StdPkl.read_list read_typeDecL s_)
              val f1 = (StdPkl.read_list read_classDecL s_)
              val f2 = (StdPkl.read_list read_classDefL s_)
              val f3 = (StdPkl.read_list read_valDecL s_)
              val f4 = (StdPkl.read_list read_funBlock s_)
            in Camelot_absyn_ASDL.PROG(f0, f1, f2, f3, f4)
            end
          | _ => raise (StdPkl.IOError "bad tag"))
        (* end case *)
        end
    
    and read_valueL s_ = 
        let
          val f0 = (read_loc s_)
          val f1 = (read_value s_)
        in (f0, f1)
        end
    
    and read_name s_ = 
        let
          val f0 = (StdPrimsUtil.read_string s_)
        in (f0)
        end
    
    and read_funBlock_list s_ = 
        (StdPkl.read_list read_funBlock s_)
    
    and read_valDecL_list s_ = 
        (StdPkl.read_list read_valDecL s_)
    
    and read_classDefL_list s_ = 
        (StdPkl.read_list read_classDefL s_)
    
    and read_classDecL_list s_ = 
        (StdPkl.read_list read_classDecL s_)
    
    and read_funDefL_list s_ = 
        (StdPkl.read_list read_funDefL s_)
    
    and read_fieldDecL_list s_ = 
        (StdPkl.read_list read_fieldDecL s_)
    
    and read_varTyL_list s_ = 
        (StdPkl.read_list read_varTyL s_)
    
    and read_oomatchRuleL_list s_ = 
        (StdPkl.read_list read_oomatchRuleL s_)
    
    and read_matchRuleL_list s_ = 
        (StdPkl.read_list read_matchRuleL s_)
    
    and read_valDec_list s_ = 
        (StdPkl.read_list read_valDec s_)
    
    and read_varNmL_list s_ = 
        (StdPkl.read_list read_varNmL s_)
    
    and read_varNmL_option s_ = 
        (StdPkl.read_option read_varNmL s_)
    
    and read_value_list s_ = 
        (StdPkl.read_list read_value s_)
    
    and read_typeConL_list s_ = 
        (StdPkl.read_list read_typeConL s_)
    
    and read_tVarNmL_list s_ = 
        (StdPkl.read_list read_tVarNmL s_)
    
    and read_rich_constructor_list s_ = 
        (StdPkl.read_list read_rich_constructor s_)
    
    and read_rich_ty_list s_ = 
        (StdPkl.read_list read_rich_ty s_)
    
    and read_ty_list s_ = 
        (StdPkl.read_list read_ty s_)
    
    and read_ty_option s_ = 
        (StdPkl.read_option read_ty s_)
    
    and read_varNm_list s_ = 
        (StdPkl.read_list read_varNm s_)
    
    and read_varNm_option s_ = 
        (StdPkl.read_option read_varNm s_)
    
    and read_funAssns_list s_ = 
        (StdPkl.read_list read_funAssns s_)
    
    and read_typeDecL_list s_ = 
        (StdPkl.read_list read_typeDecL s_)
    
    and read_assn_list s_ = 
        (StdPkl.read_list read_assn s_)
    
    and write_loc x_ s_ = 
        let
          val t = ((fn(Location.Loc(i,j))=>Camelot_absyn_ASDL.Loc(i,j))
                x_)
        in (case (t) of 
            (Camelot_absyn_ASDL.Loc(f0, f1)) => 
            ((StdPkl.write_tag 1 s_);
             (StdPrimsUtil.write_int f0 s_);
             (StdPrimsUtil.write_int f1 s_)))
        (* end case *)
        end
    
    and write_float x_ s_ = 
        let
          val t = (Real.toString x_)
        in (case (t) of 
            (f0) : Camelot_absyn_ASDL.float => (StdPrimsUtil.write_string
                f0
                s_))
        (* end case *)
        end
    
    and write_assn x_ s_ = 
        (case (x_) of 
            (f0) : Camelot_absyn_ASDL.assn => (Assertions_ASDLUtil.write_assn
                f0
                s_))
        (* end case *)
    
    and write_varNm x_ s_ = 
        (case (x_) of 
            (f0) : Camelot_absyn_ASDL.varNm => (StdPrimsUtil.write_string
                f0
                s_))
        (* end case *)
    
    and write_tVarNmL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.tVarNmL => 
            ((write_loc f0 s_);
             (StdPrimsUtil.write_string f1 s_)))
        (* end case *)
    
    and write_tVarNm x_ s_ = 
        (case (x_) of 
            (f0) : Camelot_absyn_ASDL.tVarNm => (StdPrimsUtil.write_string
                f0
                s_))
        (* end case *)
    
    and write_ty x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.INTty => (StdPkl.write_tag 1 s_)
          | Camelot_absyn_ASDL.BOOLty => (StdPkl.write_tag 2 s_)
          | Camelot_absyn_ASDL.CHARty => (StdPkl.write_tag 3 s_)
          | Camelot_absyn_ASDL.BYTEty => (StdPkl.write_tag 4 s_)
          | Camelot_absyn_ASDL.SHORTty => (StdPkl.write_tag 5 s_)
          | Camelot_absyn_ASDL.LONGty => (StdPkl.write_tag 6 s_)
          | Camelot_absyn_ASDL.FLOATty => (StdPkl.write_tag 7 s_)
          | Camelot_absyn_ASDL.DOUBLEty => (StdPkl.write_tag 8 s_)
          | Camelot_absyn_ASDL.STRINGty => (StdPkl.write_tag 9 s_)
          | Camelot_absyn_ASDL.UNITty => (StdPkl.write_tag 10 s_)
          | (Camelot_absyn_ASDL.TVARty(f0)) => 
            ((StdPkl.write_tag 11 s_);
             (write_tVarNm f0 s_))
          | (Camelot_absyn_ASDL.ARRAYty(f0)) => 
            ((StdPkl.write_tag 12 s_);
             (write_ty f0 s_))
          | (Camelot_absyn_ASDL.PRODUCTty(f0)) => 
            ((StdPkl.write_tag 13 s_);
             (StdPkl.write_list write_ty f0 s_))
          | (Camelot_absyn_ASDL.ARROWty(f0, f1)) => 
            ((StdPkl.write_tag 14 s_);
             (write_ty f0 s_);
             (write_ty f1 s_))
          | (Camelot_absyn_ASDL.CONty(f0, f1)) => 
            ((StdPkl.write_tag 15 s_);
             (StdPkl.write_list write_ty f0 s_);
             (StdPrimsUtil.write_string f1 s_))
          | (Camelot_absyn_ASDL.DIAMONDty(f0)) => 
            ((StdPkl.write_tag 16 s_);
             (StdPrimsUtil.write_string f0 s_))
          | (Camelot_absyn_ASDL.OBJECTty(f0)) => 
            ((StdPkl.write_tag 17 s_);
             (StdPrimsUtil.write_string f0 s_)))
        (* end case *)
    
    and write_heapUsage x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.HEAP => (StdPkl.write_tag 1 s_)
          | Camelot_absyn_ASDL.NOHEAP => (StdPkl.write_tag 2 s_))
        (* end case *)
    
    and write_typeCon x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.TYPEcon(f0, f1, f2)) => 
            ((StdPkl.write_tag 1 s_);
             (write_varNm f0 s_);
             (StdPkl.write_list write_ty f1 s_);
             (write_heapUsage f2 s_)))
        (* end case *)
    
    and write_typeConL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.typeConL => 
            ((write_loc f0 s_);
             (write_typeCon f1 s_)))
        (* end case *)
    
    and write_typeDec x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.TYPEdec(f0, f1, f2)) => 
            ((StdPkl.write_tag 1 s_);
             (StdPkl.write_list write_tVarNmL f0 s_);
             (write_varNm f1 s_);
             (StdPkl.write_list write_typeConL f2 s_)))
        (* end case *)
    
    and write_typeDecL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.typeDecL => 
            ((write_loc f0 s_);
             (write_typeDec f1 s_)))
        (* end case *)
    
    and write_funAssns x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.FUNASSNS(f0, f1, f2)) => 
            ((StdPkl.write_tag 1 s_);
             (write_varNm f0 s_);
             (StdPkl.write_list write_assn f1 s_);
             (StdPkl.write_list write_assn f2 s_)))
        (* end case *)
    
    and write_hints x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.HINTS(f0, f1)) => 
            ((StdPkl.write_tag 1 s_);
             (StdPkl.write_list write_typeDecL f0 s_);
             (StdPkl.write_list write_funAssns f1 s_)))
        (* end case *)
    
    and write_rich_constructor x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.RICH_CON(f0, f1, f2)) => 
            ((StdPkl.write_tag 1 s_);
             (StdPrimsUtil.write_string f0 s_);
             (StdPkl.write_list write_rich_ty f1 s_);
             (StdPrimsUtil.write_int f2 s_)))
        (* end case *)
    
    and write_rich_ty x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.RICH_INTty => (StdPkl.write_tag 1 s_)
          | Camelot_absyn_ASDL.RICH_BOOLty => (StdPkl.write_tag 2 s_)
          | Camelot_absyn_ASDL.RICH_CHARty => (StdPkl.write_tag 3 s_)
          | Camelot_absyn_ASDL.RICH_BYTEty => (StdPkl.write_tag 4 s_)
          | Camelot_absyn_ASDL.RICH_SHORTty => (StdPkl.write_tag 5 s_)
          | Camelot_absyn_ASDL.RICH_LONGty => (StdPkl.write_tag 6 s_)
          | Camelot_absyn_ASDL.RICH_FLOATty => (StdPkl.write_tag 7 s_)
          | Camelot_absyn_ASDL.RICH_DOUBLEty => (StdPkl.write_tag 8 s_)
          | Camelot_absyn_ASDL.RICH_STRINGty => (StdPkl.write_tag 9 s_)
          | Camelot_absyn_ASDL.RICH_UNITty => (StdPkl.write_tag 10 s_)
          | (Camelot_absyn_ASDL.RICH_TVARty(f0)) => 
            ((StdPkl.write_tag 11 s_);
             (write_tVarNm f0 s_))
          | (Camelot_absyn_ASDL.RICH_ARRAYty(f0)) => 
            ((StdPkl.write_tag 12 s_);
             (write_rich_ty f0 s_))
          | (Camelot_absyn_ASDL.RICH_PRODUCTty(f0)) => 
            ((StdPkl.write_tag 13 s_);
             (StdPkl.write_list write_rich_ty f0 s_))
          | (Camelot_absyn_ASDL.RICH_ARROWty(f0, f1)) => 
            ((StdPkl.write_tag 14 s_);
             (write_rich_ty f0 s_);
             (write_rich_ty f1 s_))
          | (Camelot_absyn_ASDL.RICH_CONty(f0, f1, f2)) => 
            ((StdPkl.write_tag 15 s_);
             (StdPkl.write_list write_rich_ty f0 s_);
             (write_varNm f1 s_);
             (StdPkl.write_list write_rich_constructor f2 s_))
          | (Camelot_absyn_ASDL.RICH_DIAMONDty(f0)) => 
            ((StdPkl.write_tag 16 s_);
             (StdPrimsUtil.write_string f0 s_))
          | (Camelot_absyn_ASDL.RICH_OBJECTty(f0)) => 
            ((StdPkl.write_tag 17 s_);
             (StdPrimsUtil.write_string f0 s_))
          | Camelot_absyn_ASDL.RICH_SELFty => (StdPkl.write_tag 18 s_))
        (* end case *)
    
    and write_rich_valdec x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.RICH_VALDEC(f0, f1, f2, f3)) => 
            ((StdPkl.write_tag 1 s_);
             (StdPrimsUtil.write_string f0 s_);
             (StdPrimsUtil.write_int f1 s_);
             (write_rich_ty f2 s_);
             (StdPrimsUtil.write_int f3 s_)))
        (* end case *)
    
    and write_external x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.GLOBAL => (StdPkl.write_tag 1 s_)
          | Camelot_absyn_ASDL.LOCAL => (StdPkl.write_tag 2 s_)
          | Camelot_absyn_ASDL.BUILTIN => (StdPkl.write_tag 3 s_)
          | Camelot_absyn_ASDL.EXTERN => (StdPkl.write_tag 4 s_))
        (* end case *)
    
    and write_boolX x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.TRUEval => (StdPkl.write_tag 1 s_)
          | Camelot_absyn_ASDL.FALSEval => (StdPkl.write_tag 2 s_))
        (* end case *)
    
    and write_value x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.VARval(f0, f1)) => 
            ((StdPkl.write_tag 1 s_);
             (write_varNm f0 s_);
             (write_external f1 s_))
          | (Camelot_absyn_ASDL.CHARval(f0)) => 
            ((StdPkl.write_tag 2 s_);
             (StdPrimsUtil.write_int f0 s_))
          | (Camelot_absyn_ASDL.INTval(f0)) => 
            ((StdPkl.write_tag 3 s_);
             (StdPrimsUtil.write_int f0 s_))
          | (Camelot_absyn_ASDL.FLOATval(f0)) => 
            ((StdPkl.write_tag 4 s_);
             (write_float f0 s_))
          | (Camelot_absyn_ASDL.STRINGval(f0)) => 
            ((StdPkl.write_tag 5 s_);
             (StdPrimsUtil.write_string f0 s_))
          | (Camelot_absyn_ASDL.BOOLval(f0)) => 
            ((StdPkl.write_tag 6 s_);
             (write_boolX f0 s_))
          | Camelot_absyn_ASDL.UNITval => (StdPkl.write_tag 7 s_)
          | Camelot_absyn_ASDL.NULLval => (StdPkl.write_tag 8 s_))
        (* end case *)
    
    and write_unaryOperator x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.NOTop => (StdPkl.write_tag 1 s_)
          | Camelot_absyn_ASDL.ISNULLop => (StdPkl.write_tag 2 s_))
        (* end case *)
    
    and write_binaryOperator x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.PLUSop => (StdPkl.write_tag 1 s_)
          | Camelot_absyn_ASDL.MINUSop => (StdPkl.write_tag 2 s_)
          | Camelot_absyn_ASDL.TIMESop => (StdPkl.write_tag 3 s_)
          | Camelot_absyn_ASDL.DIVop => (StdPkl.write_tag 4 s_)
          | Camelot_absyn_ASDL.MODop => (StdPkl.write_tag 5 s_)
          | Camelot_absyn_ASDL.LANDop => (StdPkl.write_tag 6 s_)
          | Camelot_absyn_ASDL.LORop => (StdPkl.write_tag 7 s_)
          | Camelot_absyn_ASDL.LXORop => (StdPkl.write_tag 8 s_)
          | Camelot_absyn_ASDL.LSLop => (StdPkl.write_tag 9 s_)
          | Camelot_absyn_ASDL.LSRop => (StdPkl.write_tag 10 s_)
          | Camelot_absyn_ASDL.ASRop => (StdPkl.write_tag 11 s_)
          | Camelot_absyn_ASDL.FPLUSop => (StdPkl.write_tag 12 s_)
          | Camelot_absyn_ASDL.FMINUSop => (StdPkl.write_tag 13 s_)
          | Camelot_absyn_ASDL.FTIMESop => (StdPkl.write_tag 14 s_)
          | Camelot_absyn_ASDL.FDIVop => (StdPkl.write_tag 15 s_)
          | Camelot_absyn_ASDL.LESSop => (StdPkl.write_tag 16 s_)
          | Camelot_absyn_ASDL.LEQop => (StdPkl.write_tag 17 s_)
          | Camelot_absyn_ASDL.EQUALSop => (StdPkl.write_tag 18 s_)
          | Camelot_absyn_ASDL.CONCATop => (StdPkl.write_tag 19 s_))
        (* end case *)
    
    and write_varNmL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.varNmL => 
            ((write_loc f0 s_);
             (StdPrimsUtil.write_string f1 s_)))
        (* end case *)
    
    and write_matchDiam x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.NOWHERE => (StdPkl.write_tag 1 s_)
          | (Camelot_absyn_ASDL.SOMEWHERE(f0)) => 
            ((StdPkl.write_tag 2 s_);
             (write_varNmL f0 s_))
          | Camelot_absyn_ASDL.DISPOSE => (StdPkl.write_tag 3 s_))
        (* end case *)
    
    and write_ooMatchPat x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.CLASSpat(f0, f1)) => 
            ((StdPkl.write_tag 1 s_);
             (write_varNm f0 s_);
             (write_varNm f1 s_))
          | Camelot_absyn_ASDL.ANYCLASSpat => (StdPkl.write_tag 2 s_))
        (* end case *)
    
    and write_instance x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.INSTANCE => (StdPkl.write_tag 1 s_)
          | Camelot_absyn_ASDL.STATIC => (StdPkl.write_tag 2 s_))
        (* end case *)
    
    and write_valDec x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.VALdec(f0, f1, f2)) => 
            ((StdPkl.write_tag 1 s_);
             (write_varNm f0 s_);
             (write_ty f1 s_);
             (write_instance f2 s_)))
        (* end case *)
    
    and write_fieldDec x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.FIELDdec(f0, f1, f2)) => 
            ((StdPkl.write_tag 1 s_);
             (write_varNm f0 s_);
             (write_ty f1 s_);
             (write_instance f2 s_)))
        (* end case *)
    
    and write_classDec x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.CLASSdec(f0, f1, f2, f3)) => 
            ((StdPkl.write_tag 1 s_);
             (write_varNm f0 s_);
             (StdPkl.write_option write_varNm f1 s_);
             (StdPkl.write_list write_varNm f2 s_);
             (StdPkl.write_list write_valDec f3 s_)))
        (* end case *)
    
    and write_varTy x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.UNITvar => (StdPkl.write_tag 1 s_)
          | (Camelot_absyn_ASDL.VAR(f0, f1)) => 
            ((StdPkl.write_tag 2 s_);
             (StdPrimsUtil.write_string f0 s_);
             (StdPkl.write_option write_ty f1 s_)))
        (* end case *)
    
    and write_test x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.TEST(f0, f1, f2)) => 
            ((StdPkl.write_tag 1 s_);
             (write_binaryOperator f0 s_);
             (write_value f1 s_);
             (write_value f2 s_)))
        (* end case *)
    
    and write_oomatchRule x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.OOMATCHrule(f0, f1)) => 
            ((StdPkl.write_tag 1 s_);
             (write_ooMatchPat f0 s_);
             (write_expL f1 s_)))
        (* end case *)
    
    and write_oomatchRuleL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.oomatchRuleL => 
            ((write_loc f0 s_);
             (write_oomatchRule f1 s_)))
        (* end case *)
    
    and write_matchRule x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.MATCHrule(f0, f1, f2, f3)) => 
            ((StdPkl.write_tag 1 s_);
             (write_varNmL f0 s_);
             (StdPkl.write_list write_varNmL f1 s_);
             (write_matchDiam f2 s_);
             (write_expL f3 s_)))
        (* end case *)
    
    and write_matchRuleL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.matchRuleL => 
            ((write_loc f0 s_);
             (write_matchRule f1 s_)))
        (* end case *)
    
    and write_expL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.expL => 
            ((write_loc f0 s_);
             (write_exp f1 s_)))
        (* end case *)
    
    and write_exp x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.VALexp(f0)) => 
            ((StdPkl.write_tag 1 s_);
             (write_value f0 s_))
          | (Camelot_absyn_ASDL.UNARYexp(f0, f1)) => 
            ((StdPkl.write_tag 2 s_);
             (write_unaryOperator f0 s_);
             (write_value f1 s_))
          | (Camelot_absyn_ASDL.BINexp(f0, f1, f2)) => 
            ((StdPkl.write_tag 3 s_);
             (write_binaryOperator f0 s_);
             (write_value f1 s_);
             (write_value f2 s_))
          | (Camelot_absyn_ASDL.APPexp(f0, f1, f2)) => 
            ((StdPkl.write_tag 4 s_);
             (write_varNm f0 s_);
             (StdPkl.write_list write_value f1 s_);
             (write_external f2 s_))
          | (Camelot_absyn_ASDL.CONexp(f0, f1, f2)) => 
            ((StdPkl.write_tag 5 s_);
             (write_varNm f0 s_);
             (StdPkl.write_list write_value f1 s_);
             (StdPkl.write_option write_varNmL f2 s_))
          | (Camelot_absyn_ASDL.INVOKEexp(f0, f1, f2)) => 
            ((StdPkl.write_tag 6 s_);
             (write_varNm f0 s_);
             (StdPrimsUtil.write_string f1 s_);
             (StdPkl.write_list write_value f2 s_))
          | (Camelot_absyn_ASDL.NEWexp(f0, f1)) => 
            ((StdPkl.write_tag 7 s_);
             (write_varNm f0 s_);
             (StdPkl.write_list write_value f1 s_))
          | (Camelot_absyn_ASDL.GETexp(f0, f1)) => 
            ((StdPkl.write_tag 8 s_);
             (write_varNm f0 s_);
             (write_varNm f1 s_))
          | (Camelot_absyn_ASDL.SGETexp(f0)) => 
            ((StdPkl.write_tag 9 s_);
             (write_varNm f0 s_))
          | (Camelot_absyn_ASDL.UPDATEexp(f0, f1)) => 
            ((StdPkl.write_tag 10 s_);
             (write_varNm f0 s_);
             (write_value f1 s_))
          | (Camelot_absyn_ASDL.SUPERMAKERexp(f0)) => 
            ((StdPkl.write_tag 11 s_);
             (StdPkl.write_list write_value f0 s_))
          | (Camelot_absyn_ASDL.COERCEexp(f0, f1)) => 
            ((StdPkl.write_tag 12 s_);
             (write_varNm f0 s_);
             (write_ty f1 s_))
          | (Camelot_absyn_ASDL.LETexp(f0, f1, f2)) => 
            ((StdPkl.write_tag 13 s_);
             (write_varNm f0 s_);
             (write_expL f1 s_);
             (write_expL f2 s_))
          | (Camelot_absyn_ASDL.IFexp(f0, f1, f2)) => 
            ((StdPkl.write_tag 14 s_);
             (write_test f0 s_);
             (write_expL f1 s_);
             (write_expL f2 s_))
          | (Camelot_absyn_ASDL.MATCHexp(f0, f1)) => 
            ((StdPkl.write_tag 15 s_);
             (write_varNm f0 s_);
             (StdPkl.write_list write_matchRuleL f1 s_))
          | (Camelot_absyn_ASDL.OOMATCHexp(f0, f1)) => 
            ((StdPkl.write_tag 16 s_);
             (write_varNm f0 s_);
             (StdPkl.write_list write_oomatchRuleL f1 s_))
          | (Camelot_absyn_ASDL.TYPEDexp(f0, f1)) => 
            ((StdPkl.write_tag 17 s_);
             (write_expL f0 s_);
             (write_ty f1 s_))
          | (Camelot_absyn_ASDL.ASSERTexp(f0, f1, f2)) => 
            ((StdPkl.write_tag 18 s_);
             (write_expL f0 s_);
             (StdPkl.write_list write_assn f1 s_);
             (StdPkl.write_list write_assn f2 s_)))
        (* end case *)
    
    and write_varTyL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.varTyL => 
            ((write_loc f0 s_);
             (write_varTy f1 s_)))
        (* end case *)
    
    and write_funDef x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.FUNdef(f0, f1, f2, f3)) => 
            ((StdPkl.write_tag 1 s_);
             (write_varNm f0 s_);
             (StdPkl.write_list write_varTyL f1 s_);
             (write_instance f2 s_);
             (write_expL f3 s_)))
        (* end case *)
    
    and write_fieldDecL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.fieldDecL => 
            ((write_loc f0 s_);
             (write_fieldDec f1 s_)))
        (* end case *)
    
    and write_funDefL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.funDefL => 
            ((write_loc f0 s_);
             (write_funDef f1 s_)))
        (* end case *)
    
    and write_classDef x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.CLASSdef(f0, f1, f2, f3, f4)) => 
            ((StdPkl.write_tag 1 s_);
             (write_varNm f0 s_);
             (StdPkl.write_option write_varNm f1 s_);
             (StdPkl.write_list write_varNm f2 s_);
             (StdPkl.write_list write_fieldDecL f3 s_);
             (StdPkl.write_list write_funDefL f4 s_)))
        (* end case *)
    
    and write_classDecL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.classDecL => 
            ((write_loc f0 s_);
             (write_classDec f1 s_)))
        (* end case *)
    
    and write_classDefL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.classDefL => 
            ((write_loc f0 s_);
             (write_classDef f1 s_)))
        (* end case *)
    
    and write_valDecL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.valDecL => 
            ((write_loc f0 s_);
             (write_valDec f1 s_)))
        (* end case *)
    
    and write_funBlock x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.FUNblock(f0)) => 
            ((StdPkl.write_tag 1 s_);
             (StdPkl.write_list write_funDefL f0 s_)))
        (* end case *)
    
    and write_program x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.PROG(f0, f1, f2, f3, f4)) => 
            ((StdPkl.write_tag 1 s_);
             (StdPkl.write_list write_typeDecL f0 s_);
             (StdPkl.write_list write_classDecL f1 s_);
             (StdPkl.write_list write_classDefL f2 s_);
             (StdPkl.write_list write_valDecL f3 s_);
             (StdPkl.write_list write_funBlock f4 s_)))
        (* end case *)
    
    and write_valueL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.valueL => 
            ((write_loc f0 s_);
             (write_value f1 s_)))
        (* end case *)
    
    and write_name x_ s_ = 
        (case (x_) of 
            (f0) : Camelot_absyn_ASDL.name => (StdPrimsUtil.write_string
                f0
                s_))
        (* end case *)
    
    and write_funBlock_list x_ s_ = 
        (StdPkl.write_list write_funBlock x_ s_)
    
    and write_valDecL_list x_ s_ = 
        (StdPkl.write_list write_valDecL x_ s_)
    
    and write_classDefL_list x_ s_ = 
        (StdPkl.write_list write_classDefL x_ s_)
    
    and write_classDecL_list x_ s_ = 
        (StdPkl.write_list write_classDecL x_ s_)
    
    and write_funDefL_list x_ s_ = 
        (StdPkl.write_list write_funDefL x_ s_)
    
    and write_fieldDecL_list x_ s_ = 
        (StdPkl.write_list write_fieldDecL x_ s_)
    
    and write_varTyL_list x_ s_ = 
        (StdPkl.write_list write_varTyL x_ s_)
    
    and write_oomatchRuleL_list x_ s_ = 
        (StdPkl.write_list write_oomatchRuleL x_ s_)
    
    and write_matchRuleL_list x_ s_ = 
        (StdPkl.write_list write_matchRuleL x_ s_)
    
    and write_valDec_list x_ s_ = 
        (StdPkl.write_list write_valDec x_ s_)
    
    and write_varNmL_list x_ s_ = 
        (StdPkl.write_list write_varNmL x_ s_)
    
    and write_varNmL_option x_ s_ = 
        (StdPkl.write_option write_varNmL x_ s_)
    
    and write_value_list x_ s_ = 
        (StdPkl.write_list write_value x_ s_)
    
    and write_typeConL_list x_ s_ = 
        (StdPkl.write_list write_typeConL x_ s_)
    
    and write_tVarNmL_list x_ s_ = 
        (StdPkl.write_list write_tVarNmL x_ s_)
    
    and write_rich_constructor_list x_ s_ = 
        (StdPkl.write_list write_rich_constructor x_ s_)
    
    and write_rich_ty_list x_ s_ = 
        (StdPkl.write_list write_rich_ty x_ s_)
    
    and write_ty_list x_ s_ = 
        (StdPkl.write_list write_ty x_ s_)
    
    and write_ty_option x_ s_ = 
        (StdPkl.write_option write_ty x_ s_)
    
    and write_varNm_list x_ s_ = 
        (StdPkl.write_list write_varNm x_ s_)
    
    and write_varNm_option x_ s_ = 
        (StdPkl.write_option write_varNm x_ s_)
    
    and write_funAssns_list x_ s_ = 
        (StdPkl.write_list write_funAssns x_ s_)
    
    and write_typeDecL_list x_ s_ = 
        (StdPkl.write_list write_typeDecL x_ s_)
    
    and write_assn_list x_ s_ = 
        (StdPkl.write_list write_assn x_ s_)
    
    and sexp_rd_loc s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_Loc" => ((fn(Camelot_absyn_ASDL.Loc(i,j))=>Location.Loc(i,j)) let
                       val f0 = (StdPrimsUtil.sexp_rd_int s_)
                       val f1 = (StdPrimsUtil.sexp_rd_int s_)
                     in Camelot_absyn_ASDL.Loc(f0, f1)
                     end)
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_float s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_float" s_);
         let
           val tmp_ = let
               val f0 = (StdPrimsUtil.sexp_rd_string s_)
             in (myRealfromString (f0))
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_assn s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_assn" s_);
         let
           val tmp_ = let
               val f0 = (Assertions_ASDLUtil.sexp_rd_assn s_)
             in (f0)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_varNm s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_varNm" s_);
         let
           val tmp_ = let
               val f0 = (StdPrimsUtil.sexp_rd_string s_)
             in (f0)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_tVarNmL s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_tVarNmL" s_);
         let
           val tmp_ = let
               val f0 = (sexp_rd_loc s_)
               val f1 = (StdPrimsUtil.sexp_rd_string s_)
             in (f0, f1)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_tVarNm s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_tVarNm" s_);
         let
           val tmp_ = let
               val f0 = (StdPrimsUtil.sexp_rd_string s_)
             in (f0)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_ty s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_INTty" => Camelot_absyn_ASDL.INTty
               | "Camelot_absyn_ASDL_BOOLty" => Camelot_absyn_ASDL.BOOLty
               | "Camelot_absyn_ASDL_CHARty" => Camelot_absyn_ASDL.CHARty
               | "Camelot_absyn_ASDL_BYTEty" => Camelot_absyn_ASDL.BYTEty
               | "Camelot_absyn_ASDL_SHORTty" => Camelot_absyn_ASDL.SHORTty
               | "Camelot_absyn_ASDL_LONGty" => Camelot_absyn_ASDL.LONGty
               | "Camelot_absyn_ASDL_FLOATty" => Camelot_absyn_ASDL.FLOATty
               | "Camelot_absyn_ASDL_DOUBLEty" => Camelot_absyn_ASDL.DOUBLEty
               | "Camelot_absyn_ASDL_STRINGty" => Camelot_absyn_ASDL.STRINGty
               | "Camelot_absyn_ASDL_UNITty" => Camelot_absyn_ASDL.UNITty
               | "Camelot_absyn_ASDL_TVARty" => let
                   val f0 = (sexp_rd_tVarNm s_)
                 in Camelot_absyn_ASDL.TVARty(f0)
                 end
               | "Camelot_absyn_ASDL_ARRAYty" => let
                   val f0 = (sexp_rd_ty s_)
                 in Camelot_absyn_ASDL.ARRAYty(f0)
                 end
               | "Camelot_absyn_ASDL_PRODUCTty" => let
                   val f0 = (SexpPkl.rd_list sexp_rd_ty s_)
                 in Camelot_absyn_ASDL.PRODUCTty(f0)
                 end
               | "Camelot_absyn_ASDL_ARROWty" => let
                   val f0 = (sexp_rd_ty s_)
                   val f1 = (sexp_rd_ty s_)
                 in Camelot_absyn_ASDL.ARROWty(f0, f1)
                 end
               | "Camelot_absyn_ASDL_CONty" => let
                   val f0 = (SexpPkl.rd_list sexp_rd_ty s_)
                   val f1 = (StdPrimsUtil.sexp_rd_string s_)
                 in Camelot_absyn_ASDL.CONty(f0, f1)
                 end
               | "Camelot_absyn_ASDL_DIAMONDty" => let
                   val f0 = (StdPrimsUtil.sexp_rd_string s_)
                 in Camelot_absyn_ASDL.DIAMONDty(f0)
                 end
               | "Camelot_absyn_ASDL_OBJECTty" => let
                   val f0 = (StdPrimsUtil.sexp_rd_string s_)
                 in Camelot_absyn_ASDL.OBJECTty(f0)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_heapUsage s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_HEAP" => Camelot_absyn_ASDL.HEAP
               | "Camelot_absyn_ASDL_NOHEAP" => Camelot_absyn_ASDL.NOHEAP
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_typeCon s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_TYPEcon" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (SexpPkl.rd_list sexp_rd_ty s_)
                   val f2 = (sexp_rd_heapUsage s_)
                 in Camelot_absyn_ASDL.TYPEcon(f0, f1, f2)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_typeConL s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_typeConL" s_);
         let
           val tmp_ = let
               val f0 = (sexp_rd_loc s_)
               val f1 = (sexp_rd_typeCon s_)
             in (f0, f1)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_typeDec s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_TYPEdec" => let
                   val f0 = (SexpPkl.rd_list sexp_rd_tVarNmL s_)
                   val f1 = (sexp_rd_varNm s_)
                   val f2 = (SexpPkl.rd_list sexp_rd_typeConL s_)
                 in Camelot_absyn_ASDL.TYPEdec(f0, f1, f2)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_typeDecL s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_typeDecL" s_);
         let
           val tmp_ = let
               val f0 = (sexp_rd_loc s_)
               val f1 = (sexp_rd_typeDec s_)
             in (f0, f1)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_funAssns s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_FUNASSNS" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (SexpPkl.rd_list sexp_rd_assn s_)
                   val f2 = (SexpPkl.rd_list sexp_rd_assn s_)
                 in Camelot_absyn_ASDL.FUNASSNS(f0, f1, f2)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_hints s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_HINTS" => let
                   val f0 = (SexpPkl.rd_list sexp_rd_typeDecL s_)
                   val f1 = (SexpPkl.rd_list sexp_rd_funAssns s_)
                 in Camelot_absyn_ASDL.HINTS(f0, f1)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_rich_constructor s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_RICH_CON" => let
                   val f0 = (StdPrimsUtil.sexp_rd_string s_)
                   val f1 = (SexpPkl.rd_list sexp_rd_rich_ty s_)
                   val f2 = (StdPrimsUtil.sexp_rd_int s_)
                 in Camelot_absyn_ASDL.RICH_CON(f0, f1, f2)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_rich_ty s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_RICH_INTty" => Camelot_absyn_ASDL.RICH_INTty
               | "Camelot_absyn_ASDL_RICH_BOOLty" => Camelot_absyn_ASDL.RICH_BOOLty
               | "Camelot_absyn_ASDL_RICH_CHARty" => Camelot_absyn_ASDL.RICH_CHARty
               | "Camelot_absyn_ASDL_RICH_BYTEty" => Camelot_absyn_ASDL.RICH_BYTEty
               | "Camelot_absyn_ASDL_RICH_SHORTty" => Camelot_absyn_ASDL.RICH_SHORTty
               | "Camelot_absyn_ASDL_RICH_LONGty" => Camelot_absyn_ASDL.RICH_LONGty
               | "Camelot_absyn_ASDL_RICH_FLOATty" => Camelot_absyn_ASDL.RICH_FLOATty
               | "Camelot_absyn_ASDL_RICH_DOUBLEty" => Camelot_absyn_ASDL.RICH_DOUBLEty
               | "Camelot_absyn_ASDL_RICH_STRINGty" => Camelot_absyn_ASDL.RICH_STRINGty
               | "Camelot_absyn_ASDL_RICH_UNITty" => Camelot_absyn_ASDL.RICH_UNITty
               | "Camelot_absyn_ASDL_RICH_TVARty" => let
                   val f0 = (sexp_rd_tVarNm s_)
                 in Camelot_absyn_ASDL.RICH_TVARty(f0)
                 end
               | "Camelot_absyn_ASDL_RICH_ARRAYty" => let
                   val f0 = (sexp_rd_rich_ty s_)
                 in Camelot_absyn_ASDL.RICH_ARRAYty(f0)
                 end
               | "Camelot_absyn_ASDL_RICH_PRODUCTty" => let
                   val f0 = (SexpPkl.rd_list sexp_rd_rich_ty s_)
                 in Camelot_absyn_ASDL.RICH_PRODUCTty(f0)
                 end
               | "Camelot_absyn_ASDL_RICH_ARROWty" => let
                   val f0 = (sexp_rd_rich_ty s_)
                   val f1 = (sexp_rd_rich_ty s_)
                 in Camelot_absyn_ASDL.RICH_ARROWty(f0, f1)
                 end
               | "Camelot_absyn_ASDL_RICH_CONty" => let
                   val f0 = (SexpPkl.rd_list sexp_rd_rich_ty s_)
                   val f1 = (sexp_rd_varNm s_)
                   val f2 = (SexpPkl.rd_list sexp_rd_rich_constructor s_)
                 in Camelot_absyn_ASDL.RICH_CONty(f0, f1, f2)
                 end
               | "Camelot_absyn_ASDL_RICH_DIAMONDty" => let
                   val f0 = (StdPrimsUtil.sexp_rd_string s_)
                 in Camelot_absyn_ASDL.RICH_DIAMONDty(f0)
                 end
               | "Camelot_absyn_ASDL_RICH_OBJECTty" => let
                   val f0 = (StdPrimsUtil.sexp_rd_string s_)
                 in Camelot_absyn_ASDL.RICH_OBJECTty(f0)
                 end
               | "Camelot_absyn_ASDL_RICH_SELFty" => Camelot_absyn_ASDL.RICH_SELFty
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_rich_valdec s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_RICH_VALDEC" => let
                   val f0 = (StdPrimsUtil.sexp_rd_string s_)
                   val f1 = (StdPrimsUtil.sexp_rd_int s_)
                   val f2 = (sexp_rd_rich_ty s_)
                   val f3 = (StdPrimsUtil.sexp_rd_int s_)
                 in Camelot_absyn_ASDL.RICH_VALDEC(f0, f1, f2, f3)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_external s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_GLOBAL" => Camelot_absyn_ASDL.GLOBAL
               | "Camelot_absyn_ASDL_LOCAL" => Camelot_absyn_ASDL.LOCAL
               | "Camelot_absyn_ASDL_BUILTIN" => Camelot_absyn_ASDL.BUILTIN
               | "Camelot_absyn_ASDL_EXTERN" => Camelot_absyn_ASDL.EXTERN
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_boolX s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_TRUEval" => Camelot_absyn_ASDL.TRUEval
               | "Camelot_absyn_ASDL_FALSEval" => Camelot_absyn_ASDL.FALSEval
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_value s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_VARval" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (sexp_rd_external s_)
                 in Camelot_absyn_ASDL.VARval(f0, f1)
                 end
               | "Camelot_absyn_ASDL_CHARval" => let
                   val f0 = (StdPrimsUtil.sexp_rd_int s_)
                 in Camelot_absyn_ASDL.CHARval(f0)
                 end
               | "Camelot_absyn_ASDL_INTval" => let
                   val f0 = (StdPrimsUtil.sexp_rd_int s_)
                 in Camelot_absyn_ASDL.INTval(f0)
                 end
               | "Camelot_absyn_ASDL_FLOATval" => let
                   val f0 = (sexp_rd_float s_)
                 in Camelot_absyn_ASDL.FLOATval(f0)
                 end
               | "Camelot_absyn_ASDL_STRINGval" => let
                   val f0 = (StdPrimsUtil.sexp_rd_string s_)
                 in Camelot_absyn_ASDL.STRINGval(f0)
                 end
               | "Camelot_absyn_ASDL_BOOLval" => let
                   val f0 = (sexp_rd_boolX s_)
                 in Camelot_absyn_ASDL.BOOLval(f0)
                 end
               | "Camelot_absyn_ASDL_UNITval" => Camelot_absyn_ASDL.UNITval
               | "Camelot_absyn_ASDL_NULLval" => Camelot_absyn_ASDL.NULLval
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_unaryOperator s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_NOTop" => Camelot_absyn_ASDL.NOTop
               | "Camelot_absyn_ASDL_ISNULLop" => Camelot_absyn_ASDL.ISNULLop
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_binaryOperator s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_PLUSop" => Camelot_absyn_ASDL.PLUSop
               | "Camelot_absyn_ASDL_MINUSop" => Camelot_absyn_ASDL.MINUSop
               | "Camelot_absyn_ASDL_TIMESop" => Camelot_absyn_ASDL.TIMESop
               | "Camelot_absyn_ASDL_DIVop" => Camelot_absyn_ASDL.DIVop
               | "Camelot_absyn_ASDL_MODop" => Camelot_absyn_ASDL.MODop
               | "Camelot_absyn_ASDL_LANDop" => Camelot_absyn_ASDL.LANDop
               | "Camelot_absyn_ASDL_LORop" => Camelot_absyn_ASDL.LORop
               | "Camelot_absyn_ASDL_LXORop" => Camelot_absyn_ASDL.LXORop
               | "Camelot_absyn_ASDL_LSLop" => Camelot_absyn_ASDL.LSLop
               | "Camelot_absyn_ASDL_LSRop" => Camelot_absyn_ASDL.LSRop
               | "Camelot_absyn_ASDL_ASRop" => Camelot_absyn_ASDL.ASRop
               | "Camelot_absyn_ASDL_FPLUSop" => Camelot_absyn_ASDL.FPLUSop
               | "Camelot_absyn_ASDL_FMINUSop" => Camelot_absyn_ASDL.FMINUSop
               | "Camelot_absyn_ASDL_FTIMESop" => Camelot_absyn_ASDL.FTIMESop
               | "Camelot_absyn_ASDL_FDIVop" => Camelot_absyn_ASDL.FDIVop
               | "Camelot_absyn_ASDL_LESSop" => Camelot_absyn_ASDL.LESSop
               | "Camelot_absyn_ASDL_LEQop" => Camelot_absyn_ASDL.LEQop
               | "Camelot_absyn_ASDL_EQUALSop" => Camelot_absyn_ASDL.EQUALSop
               | "Camelot_absyn_ASDL_CONCATop" => Camelot_absyn_ASDL.CONCATop
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_varNmL s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_varNmL" s_);
         let
           val tmp_ = let
               val f0 = (sexp_rd_loc s_)
               val f1 = (StdPrimsUtil.sexp_rd_string s_)
             in (f0, f1)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_matchDiam s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_NOWHERE" => Camelot_absyn_ASDL.NOWHERE
               | "Camelot_absyn_ASDL_SOMEWHERE" => let
                   val f0 = (sexp_rd_varNmL s_)
                 in Camelot_absyn_ASDL.SOMEWHERE(f0)
                 end
               | "Camelot_absyn_ASDL_DISPOSE" => Camelot_absyn_ASDL.DISPOSE
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_ooMatchPat s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_CLASSpat" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (sexp_rd_varNm s_)
                 in Camelot_absyn_ASDL.CLASSpat(f0, f1)
                 end
               | "Camelot_absyn_ASDL_ANYCLASSpat" => Camelot_absyn_ASDL.ANYCLASSpat
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_instance s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_INSTANCE" => Camelot_absyn_ASDL.INSTANCE
               | "Camelot_absyn_ASDL_STATIC" => Camelot_absyn_ASDL.STATIC
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_valDec s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_VALdec" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (sexp_rd_ty s_)
                   val f2 = (sexp_rd_instance s_)
                 in Camelot_absyn_ASDL.VALdec(f0, f1, f2)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_fieldDec s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_FIELDdec" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (sexp_rd_ty s_)
                   val f2 = (sexp_rd_instance s_)
                 in Camelot_absyn_ASDL.FIELDdec(f0, f1, f2)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_classDec s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_CLASSdec" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (SexpPkl.rd_option sexp_rd_varNm s_)
                   val f2 = (SexpPkl.rd_list sexp_rd_varNm s_)
                   val f3 = (SexpPkl.rd_list sexp_rd_valDec s_)
                 in Camelot_absyn_ASDL.CLASSdec(f0, f1, f2, f3)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_varTy s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_UNITvar" => Camelot_absyn_ASDL.UNITvar
               | "Camelot_absyn_ASDL_VAR" => let
                   val f0 = (StdPrimsUtil.sexp_rd_string s_)
                   val f1 = (SexpPkl.rd_option sexp_rd_ty s_)
                 in Camelot_absyn_ASDL.VAR(f0, f1)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_test s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_TEST" => let
                   val f0 = (sexp_rd_binaryOperator s_)
                   val f1 = (sexp_rd_value s_)
                   val f2 = (sexp_rd_value s_)
                 in Camelot_absyn_ASDL.TEST(f0, f1, f2)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_oomatchRule s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_OOMATCHrule" => let
                   val f0 = (sexp_rd_ooMatchPat s_)
                   val f1 = (sexp_rd_expL s_)
                 in Camelot_absyn_ASDL.OOMATCHrule(f0, f1)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_oomatchRuleL s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_oomatchRuleL" s_);
         let
           val tmp_ = let
               val f0 = (sexp_rd_loc s_)
               val f1 = (sexp_rd_oomatchRule s_)
             in (f0, f1)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_matchRule s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_MATCHrule" => let
                   val f0 = (sexp_rd_varNmL s_)
                   val f1 = (SexpPkl.rd_list sexp_rd_varNmL s_)
                   val f2 = (sexp_rd_matchDiam s_)
                   val f3 = (sexp_rd_expL s_)
                 in Camelot_absyn_ASDL.MATCHrule(f0, f1, f2, f3)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_matchRuleL s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_matchRuleL" s_);
         let
           val tmp_ = let
               val f0 = (sexp_rd_loc s_)
               val f1 = (sexp_rd_matchRule s_)
             in (f0, f1)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_expL s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_expL" s_);
         let
           val tmp_ = let
               val f0 = (sexp_rd_loc s_)
               val f1 = (sexp_rd_exp s_)
             in (f0, f1)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_exp s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_VALexp" => let
                   val f0 = (sexp_rd_value s_)
                 in Camelot_absyn_ASDL.VALexp(f0)
                 end
               | "Camelot_absyn_ASDL_UNARYexp" => let
                   val f0 = (sexp_rd_unaryOperator s_)
                   val f1 = (sexp_rd_value s_)
                 in Camelot_absyn_ASDL.UNARYexp(f0, f1)
                 end
               | "Camelot_absyn_ASDL_BINexp" => let
                   val f0 = (sexp_rd_binaryOperator s_)
                   val f1 = (sexp_rd_value s_)
                   val f2 = (sexp_rd_value s_)
                 in Camelot_absyn_ASDL.BINexp(f0, f1, f2)
                 end
               | "Camelot_absyn_ASDL_APPexp" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (SexpPkl.rd_list sexp_rd_value s_)
                   val f2 = (sexp_rd_external s_)
                 in Camelot_absyn_ASDL.APPexp(f0, f1, f2)
                 end
               | "Camelot_absyn_ASDL_CONexp" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (SexpPkl.rd_list sexp_rd_value s_)
                   val f2 = (SexpPkl.rd_option sexp_rd_varNmL s_)
                 in Camelot_absyn_ASDL.CONexp(f0, f1, f2)
                 end
               | "Camelot_absyn_ASDL_INVOKEexp" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (StdPrimsUtil.sexp_rd_string s_)
                   val f2 = (SexpPkl.rd_list sexp_rd_value s_)
                 in Camelot_absyn_ASDL.INVOKEexp(f0, f1, f2)
                 end
               | "Camelot_absyn_ASDL_NEWexp" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (SexpPkl.rd_list sexp_rd_value s_)
                 in Camelot_absyn_ASDL.NEWexp(f0, f1)
                 end
               | "Camelot_absyn_ASDL_GETexp" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (sexp_rd_varNm s_)
                 in Camelot_absyn_ASDL.GETexp(f0, f1)
                 end
               | "Camelot_absyn_ASDL_SGETexp" => let
                   val f0 = (sexp_rd_varNm s_)
                 in Camelot_absyn_ASDL.SGETexp(f0)
                 end
               | "Camelot_absyn_ASDL_UPDATEexp" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (sexp_rd_value s_)
                 in Camelot_absyn_ASDL.UPDATEexp(f0, f1)
                 end
               | "Camelot_absyn_ASDL_SUPERMAKERexp" => let
                   val f0 = (SexpPkl.rd_list sexp_rd_value s_)
                 in Camelot_absyn_ASDL.SUPERMAKERexp(f0)
                 end
               | "Camelot_absyn_ASDL_COERCEexp" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (sexp_rd_ty s_)
                 in Camelot_absyn_ASDL.COERCEexp(f0, f1)
                 end
               | "Camelot_absyn_ASDL_LETexp" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (sexp_rd_expL s_)
                   val f2 = (sexp_rd_expL s_)
                 in Camelot_absyn_ASDL.LETexp(f0, f1, f2)
                 end
               | "Camelot_absyn_ASDL_IFexp" => let
                   val f0 = (sexp_rd_test s_)
                   val f1 = (sexp_rd_expL s_)
                   val f2 = (sexp_rd_expL s_)
                 in Camelot_absyn_ASDL.IFexp(f0, f1, f2)
                 end
               | "Camelot_absyn_ASDL_MATCHexp" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (SexpPkl.rd_list sexp_rd_matchRuleL s_)
                 in Camelot_absyn_ASDL.MATCHexp(f0, f1)
                 end
               | "Camelot_absyn_ASDL_OOMATCHexp" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (SexpPkl.rd_list sexp_rd_oomatchRuleL s_)
                 in Camelot_absyn_ASDL.OOMATCHexp(f0, f1)
                 end
               | "Camelot_absyn_ASDL_TYPEDexp" => let
                   val f0 = (sexp_rd_expL s_)
                   val f1 = (sexp_rd_ty s_)
                 in Camelot_absyn_ASDL.TYPEDexp(f0, f1)
                 end
               | "Camelot_absyn_ASDL_ASSERTexp" => let
                   val f0 = (sexp_rd_expL s_)
                   val f1 = (SexpPkl.rd_list sexp_rd_assn s_)
                   val f2 = (SexpPkl.rd_list sexp_rd_assn s_)
                 in Camelot_absyn_ASDL.ASSERTexp(f0, f1, f2)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_varTyL s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_varTyL" s_);
         let
           val tmp_ = let
               val f0 = (sexp_rd_loc s_)
               val f1 = (sexp_rd_varTy s_)
             in (f0, f1)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_funDef s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_FUNdef" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (SexpPkl.rd_list sexp_rd_varTyL s_)
                   val f2 = (sexp_rd_instance s_)
                   val f3 = (sexp_rd_expL s_)
                 in Camelot_absyn_ASDL.FUNdef(f0, f1, f2, f3)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_fieldDecL s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_fieldDecL" s_);
         let
           val tmp_ = let
               val f0 = (sexp_rd_loc s_)
               val f1 = (sexp_rd_fieldDec s_)
             in (f0, f1)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_funDefL s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_funDefL" s_);
         let
           val tmp_ = let
               val f0 = (sexp_rd_loc s_)
               val f1 = (sexp_rd_funDef s_)
             in (f0, f1)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_classDef s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_CLASSdef" => let
                   val f0 = (sexp_rd_varNm s_)
                   val f1 = (SexpPkl.rd_option sexp_rd_varNm s_)
                   val f2 = (SexpPkl.rd_list sexp_rd_varNm s_)
                   val f3 = (SexpPkl.rd_list sexp_rd_fieldDecL s_)
                   val f4 = (SexpPkl.rd_list sexp_rd_funDefL s_)
                 in Camelot_absyn_ASDL.CLASSdef(f0, f1, f2, f3, f4)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_classDecL s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_classDecL" s_);
         let
           val tmp_ = let
               val f0 = (sexp_rd_loc s_)
               val f1 = (sexp_rd_classDec s_)
             in (f0, f1)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_classDefL s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_classDefL" s_);
         let
           val tmp_ = let
               val f0 = (sexp_rd_loc s_)
               val f1 = (sexp_rd_classDef s_)
             in (f0, f1)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_valDecL s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_valDecL" s_);
         let
           val tmp_ = let
               val f0 = (sexp_rd_loc s_)
               val f1 = (sexp_rd_valDec s_)
             in (f0, f1)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_funBlock s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_FUNblock" => let
                   val f0 = (SexpPkl.rd_list sexp_rd_funDefL s_)
                 in Camelot_absyn_ASDL.FUNblock(f0)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_program s_ = 
        
        ((SexpPkl.rd_lp s_);
         let
           val tmp_ = let
               val t = (SexpPkl.get_sym s_)
             in (case (t) of 
                 "Camelot_absyn_ASDL_PROG" => let
                   val f0 = (SexpPkl.rd_list sexp_rd_typeDecL s_)
                   val f1 = (SexpPkl.rd_list sexp_rd_classDecL s_)
                   val f2 = (SexpPkl.rd_list sexp_rd_classDefL s_)
                   val f3 = (SexpPkl.rd_list sexp_rd_valDecL s_)
                   val f4 = (SexpPkl.rd_list sexp_rd_funBlock s_)
                 in Camelot_absyn_ASDL.PROG(f0, f1, f2, f3, f4)
                 end
               | _ => raise (SexpPkl.IOError "bad tag"))
             (* end case *)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_valueL s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_valueL" s_);
         let
           val tmp_ = let
               val f0 = (sexp_rd_loc s_)
               val f1 = (sexp_rd_value s_)
             in (f0, f1)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_name s_ = 
        
        ((SexpPkl.rd_lp s_);
         (SexpPkl.rd_sym "Camelot_absyn_ASDL_name" s_);
         let
           val tmp_ = let
               val f0 = (StdPrimsUtil.sexp_rd_string s_)
             in (f0)
             end
         in 
         ((SexpPkl.rd_rp s_);
          tmp_)
         end)
    
    and sexp_rd_funBlock_list s_ = 
        (SexpPkl.rd_list sexp_rd_funBlock s_)
    
    and sexp_rd_valDecL_list s_ = 
        (SexpPkl.rd_list sexp_rd_valDecL s_)
    
    and sexp_rd_classDefL_list s_ = 
        (SexpPkl.rd_list sexp_rd_classDefL s_)
    
    and sexp_rd_classDecL_list s_ = 
        (SexpPkl.rd_list sexp_rd_classDecL s_)
    
    and sexp_rd_funDefL_list s_ = 
        (SexpPkl.rd_list sexp_rd_funDefL s_)
    
    and sexp_rd_fieldDecL_list s_ = 
        (SexpPkl.rd_list sexp_rd_fieldDecL s_)
    
    and sexp_rd_varTyL_list s_ = 
        (SexpPkl.rd_list sexp_rd_varTyL s_)
    
    and sexp_rd_oomatchRuleL_list s_ = 
        (SexpPkl.rd_list sexp_rd_oomatchRuleL s_)
    
    and sexp_rd_matchRuleL_list s_ = 
        (SexpPkl.rd_list sexp_rd_matchRuleL s_)
    
    and sexp_rd_valDec_list s_ = 
        (SexpPkl.rd_list sexp_rd_valDec s_)
    
    and sexp_rd_varNmL_list s_ = 
        (SexpPkl.rd_list sexp_rd_varNmL s_)
    
    and sexp_rd_varNmL_option s_ = 
        (SexpPkl.rd_option sexp_rd_varNmL s_)
    
    and sexp_rd_value_list s_ = 
        (SexpPkl.rd_list sexp_rd_value s_)
    
    and sexp_rd_typeConL_list s_ = 
        (SexpPkl.rd_list sexp_rd_typeConL s_)
    
    and sexp_rd_tVarNmL_list s_ = 
        (SexpPkl.rd_list sexp_rd_tVarNmL s_)
    
    and sexp_rd_rich_constructor_list s_ = 
        (SexpPkl.rd_list sexp_rd_rich_constructor s_)
    
    and sexp_rd_rich_ty_list s_ = 
        (SexpPkl.rd_list sexp_rd_rich_ty s_)
    
    and sexp_rd_ty_list s_ = 
        (SexpPkl.rd_list sexp_rd_ty s_)
    
    and sexp_rd_ty_option s_ = 
        (SexpPkl.rd_option sexp_rd_ty s_)
    
    and sexp_rd_varNm_list s_ = 
        (SexpPkl.rd_list sexp_rd_varNm s_)
    
    and sexp_rd_varNm_option s_ = 
        (SexpPkl.rd_option sexp_rd_varNm s_)
    
    and sexp_rd_funAssns_list s_ = 
        (SexpPkl.rd_list sexp_rd_funAssns s_)
    
    and sexp_rd_typeDecL_list s_ = 
        (SexpPkl.rd_list sexp_rd_typeDecL s_)
    
    and sexp_rd_assn_list s_ = 
        (SexpPkl.rd_list sexp_rd_assn s_)
    
    and sexp_wr_loc x_ s_ = 
        let
          val t = ((fn(Location.Loc(i,j))=>Camelot_absyn_ASDL.Loc(i,j))
                x_)
        in (case (t) of 
            (Camelot_absyn_ASDL.Loc(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_Loc" s_);
             (StdPrimsUtil.sexp_wr_int f0 s_);
             (StdPrimsUtil.sexp_wr_int f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
        end
    
    and sexp_wr_float x_ s_ = 
        let
          val t = (Real.toString x_)
        in (case (t) of 
            (f0) : Camelot_absyn_ASDL.float => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_float" s_);
             (StdPrimsUtil.sexp_wr_string f0 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
        end
    
    and sexp_wr_assn x_ s_ = 
        (case (x_) of 
            (f0) : Camelot_absyn_ASDL.assn => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_assn" s_);
             (Assertions_ASDLUtil.sexp_wr_assn f0 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_varNm x_ s_ = 
        (case (x_) of 
            (f0) : Camelot_absyn_ASDL.varNm => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_varNm" s_);
             (StdPrimsUtil.sexp_wr_string f0 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_tVarNmL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.tVarNmL => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_tVarNmL" s_);
             (sexp_wr_loc f0 s_);
             (StdPrimsUtil.sexp_wr_string f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_tVarNm x_ s_ = 
        (case (x_) of 
            (f0) : Camelot_absyn_ASDL.tVarNm => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_tVarNm" s_);
             (StdPrimsUtil.sexp_wr_string f0 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_ty x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.INTty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_INTty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.BOOLty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_BOOLty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.CHARty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_CHARty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.BYTEty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_BYTEty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.SHORTty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_SHORTty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.LONGty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_LONGty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.FLOATty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_FLOATty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.DOUBLEty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_DOUBLEty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.STRINGty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_STRINGty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.UNITty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_UNITty" s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.TVARty(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_TVARty" s_);
             (sexp_wr_tVarNm f0 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.ARRAYty(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_ARRAYty" s_);
             (sexp_wr_ty f0 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.PRODUCTty(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_PRODUCTty" s_);
             (SexpPkl.wr_list sexp_wr_ty f0 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.ARROWty(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_ARROWty" s_);
             (sexp_wr_ty f0 s_);
             (sexp_wr_ty f1 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.CONty(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_CONty" s_);
             (SexpPkl.wr_list sexp_wr_ty f0 s_);
             (StdPrimsUtil.sexp_wr_string f1 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.DIAMONDty(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_DIAMONDty" s_);
             (StdPrimsUtil.sexp_wr_string f0 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.OBJECTty(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_OBJECTty" s_);
             (StdPrimsUtil.sexp_wr_string f0 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_heapUsage x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.HEAP => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_HEAP" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.NOHEAP => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_NOHEAP" s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_typeCon x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.TYPEcon(f0, f1, f2)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_TYPEcon" s_);
             (sexp_wr_varNm f0 s_);
             (SexpPkl.wr_list sexp_wr_ty f1 s_);
             (sexp_wr_heapUsage f2 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_typeConL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.typeConL => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_typeConL" s_);
             (sexp_wr_loc f0 s_);
             (sexp_wr_typeCon f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_typeDec x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.TYPEdec(f0, f1, f2)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_TYPEdec" s_);
             (SexpPkl.wr_list sexp_wr_tVarNmL f0 s_);
             (sexp_wr_varNm f1 s_);
             (SexpPkl.wr_list sexp_wr_typeConL f2 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_typeDecL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.typeDecL => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_typeDecL" s_);
             (sexp_wr_loc f0 s_);
             (sexp_wr_typeDec f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_funAssns x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.FUNASSNS(f0, f1, f2)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_FUNASSNS" s_);
             (sexp_wr_varNm f0 s_);
             (SexpPkl.wr_list sexp_wr_assn f1 s_);
             (SexpPkl.wr_list sexp_wr_assn f2 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_hints x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.HINTS(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_HINTS" s_);
             (SexpPkl.wr_list sexp_wr_typeDecL f0 s_);
             (SexpPkl.wr_list sexp_wr_funAssns f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_rich_constructor x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.RICH_CON(f0, f1, f2)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_CON" s_);
             (StdPrimsUtil.sexp_wr_string f0 s_);
             (SexpPkl.wr_list sexp_wr_rich_ty f1 s_);
             (StdPrimsUtil.sexp_wr_int f2 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_rich_ty x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.RICH_INTty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_INTty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.RICH_BOOLty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_BOOLty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.RICH_CHARty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_CHARty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.RICH_BYTEty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_BYTEty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.RICH_SHORTty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_SHORTty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.RICH_LONGty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_LONGty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.RICH_FLOATty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_FLOATty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.RICH_DOUBLEty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_DOUBLEty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.RICH_STRINGty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_STRINGty" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.RICH_UNITty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_UNITty" s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.RICH_TVARty(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_TVARty" s_);
             (sexp_wr_tVarNm f0 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.RICH_ARRAYty(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_ARRAYty" s_);
             (sexp_wr_rich_ty f0 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.RICH_PRODUCTty(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_PRODUCTty" s_);
             (SexpPkl.wr_list sexp_wr_rich_ty f0 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.RICH_ARROWty(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_ARROWty" s_);
             (sexp_wr_rich_ty f0 s_);
             (sexp_wr_rich_ty f1 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.RICH_CONty(f0, f1, f2)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_CONty" s_);
             (SexpPkl.wr_list sexp_wr_rich_ty f0 s_);
             (sexp_wr_varNm f1 s_);
             (SexpPkl.wr_list sexp_wr_rich_constructor f2 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.RICH_DIAMONDty(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_DIAMONDty" s_);
             (StdPrimsUtil.sexp_wr_string f0 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.RICH_OBJECTty(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_OBJECTty" s_);
             (StdPrimsUtil.sexp_wr_string f0 s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.RICH_SELFty => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_SELFty" s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_rich_valdec x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.RICH_VALDEC(f0, f1, f2, f3)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_RICH_VALDEC" s_);
             (StdPrimsUtil.sexp_wr_string f0 s_);
             (StdPrimsUtil.sexp_wr_int f1 s_);
             (sexp_wr_rich_ty f2 s_);
             (StdPrimsUtil.sexp_wr_int f3 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_external x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.GLOBAL => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_GLOBAL" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.LOCAL => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_LOCAL" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.BUILTIN => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_BUILTIN" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.EXTERN => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_EXTERN" s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_boolX x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.TRUEval => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_TRUEval" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.FALSEval => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_FALSEval" s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_value x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.VARval(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_VARval" s_);
             (sexp_wr_varNm f0 s_);
             (sexp_wr_external f1 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.CHARval(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_CHARval" s_);
             (StdPrimsUtil.sexp_wr_int f0 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.INTval(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_INTval" s_);
             (StdPrimsUtil.sexp_wr_int f0 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.FLOATval(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_FLOATval" s_);
             (sexp_wr_float f0 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.STRINGval(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_STRINGval" s_);
             (StdPrimsUtil.sexp_wr_string f0 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.BOOLval(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_BOOLval" s_);
             (sexp_wr_boolX f0 s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.UNITval => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_UNITval" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.NULLval => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_NULLval" s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_unaryOperator x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.NOTop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_NOTop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.ISNULLop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_ISNULLop" s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_binaryOperator x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.PLUSop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_PLUSop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.MINUSop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_MINUSop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.TIMESop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_TIMESop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.DIVop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_DIVop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.MODop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_MODop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.LANDop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_LANDop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.LORop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_LORop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.LXORop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_LXORop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.LSLop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_LSLop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.LSRop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_LSRop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.ASRop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_ASRop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.FPLUSop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_FPLUSop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.FMINUSop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_FMINUSop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.FTIMESop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_FTIMESop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.FDIVop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_FDIVop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.LESSop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_LESSop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.LEQop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_LEQop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.EQUALSop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_EQUALSop" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.CONCATop => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_CONCATop" s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_varNmL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.varNmL => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_varNmL" s_);
             (sexp_wr_loc f0 s_);
             (StdPrimsUtil.sexp_wr_string f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_matchDiam x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.NOWHERE => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_NOWHERE" s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.SOMEWHERE(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_SOMEWHERE" s_);
             (sexp_wr_varNmL f0 s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.DISPOSE => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_DISPOSE" s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_ooMatchPat x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.CLASSpat(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_CLASSpat" s_);
             (sexp_wr_varNm f0 s_);
             (sexp_wr_varNm f1 s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.ANYCLASSpat => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_ANYCLASSpat" s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_instance x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.INSTANCE => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_INSTANCE" s_);
             (SexpPkl.wr_rp s_))
          | Camelot_absyn_ASDL.STATIC => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_STATIC" s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_valDec x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.VALdec(f0, f1, f2)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_VALdec" s_);
             (sexp_wr_varNm f0 s_);
             (sexp_wr_ty f1 s_);
             (sexp_wr_instance f2 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_fieldDec x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.FIELDdec(f0, f1, f2)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_FIELDdec" s_);
             (sexp_wr_varNm f0 s_);
             (sexp_wr_ty f1 s_);
             (sexp_wr_instance f2 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_classDec x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.CLASSdec(f0, f1, f2, f3)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_CLASSdec" s_);
             (sexp_wr_varNm f0 s_);
             (SexpPkl.wr_option sexp_wr_varNm f1 s_);
             (SexpPkl.wr_list sexp_wr_varNm f2 s_);
             (SexpPkl.wr_list sexp_wr_valDec f3 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_varTy x_ s_ = 
        (case (x_) of 
            Camelot_absyn_ASDL.UNITvar => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_UNITvar" s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.VAR(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_VAR" s_);
             (StdPrimsUtil.sexp_wr_string f0 s_);
             (SexpPkl.wr_option sexp_wr_ty f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_test x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.TEST(f0, f1, f2)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_TEST" s_);
             (sexp_wr_binaryOperator f0 s_);
             (sexp_wr_value f1 s_);
             (sexp_wr_value f2 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_oomatchRule x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.OOMATCHrule(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_OOMATCHrule" s_);
             (sexp_wr_ooMatchPat f0 s_);
             (sexp_wr_expL f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_oomatchRuleL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.oomatchRuleL => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_oomatchRuleL" s_);
             (sexp_wr_loc f0 s_);
             (sexp_wr_oomatchRule f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_matchRule x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.MATCHrule(f0, f1, f2, f3)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_MATCHrule" s_);
             (sexp_wr_varNmL f0 s_);
             (SexpPkl.wr_list sexp_wr_varNmL f1 s_);
             (sexp_wr_matchDiam f2 s_);
             (sexp_wr_expL f3 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_matchRuleL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.matchRuleL => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_matchRuleL" s_);
             (sexp_wr_loc f0 s_);
             (sexp_wr_matchRule f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_expL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.expL => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_expL" s_);
             (sexp_wr_loc f0 s_);
             (sexp_wr_exp f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_exp x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.VALexp(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_VALexp" s_);
             (sexp_wr_value f0 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.UNARYexp(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_UNARYexp" s_);
             (sexp_wr_unaryOperator f0 s_);
             (sexp_wr_value f1 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.BINexp(f0, f1, f2)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_BINexp" s_);
             (sexp_wr_binaryOperator f0 s_);
             (sexp_wr_value f1 s_);
             (sexp_wr_value f2 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.APPexp(f0, f1, f2)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_APPexp" s_);
             (sexp_wr_varNm f0 s_);
             (SexpPkl.wr_list sexp_wr_value f1 s_);
             (sexp_wr_external f2 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.CONexp(f0, f1, f2)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_CONexp" s_);
             (sexp_wr_varNm f0 s_);
             (SexpPkl.wr_list sexp_wr_value f1 s_);
             (SexpPkl.wr_option sexp_wr_varNmL f2 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.INVOKEexp(f0, f1, f2)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_INVOKEexp" s_);
             (sexp_wr_varNm f0 s_);
             (StdPrimsUtil.sexp_wr_string f1 s_);
             (SexpPkl.wr_list sexp_wr_value f2 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.NEWexp(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_NEWexp" s_);
             (sexp_wr_varNm f0 s_);
             (SexpPkl.wr_list sexp_wr_value f1 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.GETexp(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_GETexp" s_);
             (sexp_wr_varNm f0 s_);
             (sexp_wr_varNm f1 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.SGETexp(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_SGETexp" s_);
             (sexp_wr_varNm f0 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.UPDATEexp(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_UPDATEexp" s_);
             (sexp_wr_varNm f0 s_);
             (sexp_wr_value f1 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.SUPERMAKERexp(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_SUPERMAKERexp" s_);
             (SexpPkl.wr_list sexp_wr_value f0 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.COERCEexp(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_COERCEexp" s_);
             (sexp_wr_varNm f0 s_);
             (sexp_wr_ty f1 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.LETexp(f0, f1, f2)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_LETexp" s_);
             (sexp_wr_varNm f0 s_);
             (sexp_wr_expL f1 s_);
             (sexp_wr_expL f2 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.IFexp(f0, f1, f2)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_IFexp" s_);
             (sexp_wr_test f0 s_);
             (sexp_wr_expL f1 s_);
             (sexp_wr_expL f2 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.MATCHexp(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_MATCHexp" s_);
             (sexp_wr_varNm f0 s_);
             (SexpPkl.wr_list sexp_wr_matchRuleL f1 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.OOMATCHexp(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_OOMATCHexp" s_);
             (sexp_wr_varNm f0 s_);
             (SexpPkl.wr_list sexp_wr_oomatchRuleL f1 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.TYPEDexp(f0, f1)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_TYPEDexp" s_);
             (sexp_wr_expL f0 s_);
             (sexp_wr_ty f1 s_);
             (SexpPkl.wr_rp s_))
          | (Camelot_absyn_ASDL.ASSERTexp(f0, f1, f2)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_ASSERTexp" s_);
             (sexp_wr_expL f0 s_);
             (SexpPkl.wr_list sexp_wr_assn f1 s_);
             (SexpPkl.wr_list sexp_wr_assn f2 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_varTyL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.varTyL => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_varTyL" s_);
             (sexp_wr_loc f0 s_);
             (sexp_wr_varTy f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_funDef x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.FUNdef(f0, f1, f2, f3)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_FUNdef" s_);
             (sexp_wr_varNm f0 s_);
             (SexpPkl.wr_list sexp_wr_varTyL f1 s_);
             (sexp_wr_instance f2 s_);
             (sexp_wr_expL f3 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_fieldDecL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.fieldDecL => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_fieldDecL" s_);
             (sexp_wr_loc f0 s_);
             (sexp_wr_fieldDec f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_funDefL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.funDefL => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_funDefL" s_);
             (sexp_wr_loc f0 s_);
             (sexp_wr_funDef f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_classDef x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.CLASSdef(f0, f1, f2, f3, f4)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_CLASSdef" s_);
             (sexp_wr_varNm f0 s_);
             (SexpPkl.wr_option sexp_wr_varNm f1 s_);
             (SexpPkl.wr_list sexp_wr_varNm f2 s_);
             (SexpPkl.wr_list sexp_wr_fieldDecL f3 s_);
             (SexpPkl.wr_list sexp_wr_funDefL f4 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_classDecL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.classDecL => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_classDecL" s_);
             (sexp_wr_loc f0 s_);
             (sexp_wr_classDec f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_classDefL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.classDefL => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_classDefL" s_);
             (sexp_wr_loc f0 s_);
             (sexp_wr_classDef f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_valDecL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.valDecL => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_valDecL" s_);
             (sexp_wr_loc f0 s_);
             (sexp_wr_valDec f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_funBlock x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.FUNblock(f0)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_FUNblock" s_);
             (SexpPkl.wr_list sexp_wr_funDefL f0 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_program x_ s_ = 
        (case (x_) of 
            (Camelot_absyn_ASDL.PROG(f0, f1, f2, f3, f4)) => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_PROG" s_);
             (SexpPkl.wr_list sexp_wr_typeDecL f0 s_);
             (SexpPkl.wr_list sexp_wr_classDecL f1 s_);
             (SexpPkl.wr_list sexp_wr_classDefL f2 s_);
             (SexpPkl.wr_list sexp_wr_valDecL f3 s_);
             (SexpPkl.wr_list sexp_wr_funBlock f4 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_valueL x_ s_ = 
        (case (x_) of 
            (f0, f1) : Camelot_absyn_ASDL.valueL => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_valueL" s_);
             (sexp_wr_loc f0 s_);
             (sexp_wr_value f1 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_name x_ s_ = 
        (case (x_) of 
            (f0) : Camelot_absyn_ASDL.name => 
            ((SexpPkl.wr_lp s_);
             (SexpPkl.wr_sym "Camelot_absyn_ASDL_name" s_);
             (StdPrimsUtil.sexp_wr_string f0 s_);
             (SexpPkl.wr_rp s_)))
        (* end case *)
    
    and sexp_wr_funBlock_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_funBlock x_ s_)
    
    and sexp_wr_valDecL_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_valDecL x_ s_)
    
    and sexp_wr_classDefL_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_classDefL x_ s_)
    
    and sexp_wr_classDecL_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_classDecL x_ s_)
    
    and sexp_wr_funDefL_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_funDefL x_ s_)
    
    and sexp_wr_fieldDecL_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_fieldDecL x_ s_)
    
    and sexp_wr_varTyL_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_varTyL x_ s_)
    
    and sexp_wr_oomatchRuleL_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_oomatchRuleL x_ s_)
    
    and sexp_wr_matchRuleL_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_matchRuleL x_ s_)
    
    and sexp_wr_valDec_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_valDec x_ s_)
    
    and sexp_wr_varNmL_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_varNmL x_ s_)
    
    and sexp_wr_varNmL_option x_ s_ = 
        (SexpPkl.wr_option sexp_wr_varNmL x_ s_)
    
    and sexp_wr_value_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_value x_ s_)
    
    and sexp_wr_typeConL_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_typeConL x_ s_)
    
    and sexp_wr_tVarNmL_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_tVarNmL x_ s_)
    
    and sexp_wr_rich_constructor_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_rich_constructor x_ s_)
    
    and sexp_wr_rich_ty_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_rich_ty x_ s_)
    
    and sexp_wr_ty_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_ty x_ s_)
    
    and sexp_wr_ty_option x_ s_ = 
        (SexpPkl.wr_option sexp_wr_ty x_ s_)
    
    and sexp_wr_varNm_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_varNm x_ s_)
    
    and sexp_wr_varNm_option x_ s_ = 
        (SexpPkl.wr_option sexp_wr_varNm x_ s_)
    
    and sexp_wr_funAssns_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_funAssns x_ s_)
    
    and sexp_wr_typeDecL_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_typeDecL x_ s_)
    
    and sexp_wr_assn_list x_ s_ = 
        (SexpPkl.wr_list sexp_wr_assn x_ s_)
    
    
  end (* struct *)

